/*!
 * @copyright Copyright &copy; Kartik Visweswaran, Krajee.com, 2014
 * @version 2.9.0
 *
 * Grid Export Validation Module for Yii's Gridview. Supports export of
 * grid data as CSV, HTML, or Excel.
 *
 * Author: Kartik Visweswaran
 * Copyright: 2014, Kartik Visweswaran, Krajee.com
 * For more JQuery plugins visit http://plugins.krajee.com
 * For more Yii related demos visit http://demos.krajee.com
 */!function(e){var t=function(e,t,o){return e.split(t).join(o)},o=function(t,o){return null===t||void 0===t||t==[]||""===t||o&&""===e.trim(t)};popupDialog=function(e,t,o,n){var i=screen.width/2-o/2,r=60,l=window.open("",t,"",!0);return l.close(),window.open(e,t,"toolbar=no, location=no, directories=no, status=yes, menubar=no, scrollbars=no, resizable=no, copyhistory=no, width="+o+", height="+n+", top="+r+", left="+i)},slug=function(e){return e.toLowerCase().replace(/[^\w ]+/g,"").replace(/ +/g,"-")};var n={html:'<!DOCTYPE html><meta http-equiv="Content-Type" content="text/html;charset={encoding}"/><meta http-equiv="X-UA-Compatible" content="IE=edge;chrome=1"/>{css}<style>.kv-wrap{padding:20px;}.kv-align-center{text-align:center;}.kv-align-left{text-align:left;}.kv-align-right{text-align:right;}.kv-align-top{vertical-align:top!important;}.kv-align-bottom{vertical-align:bottom!important;}.kv-align-middle{vertical-align:middle!important;}.kv-page-summary{border-top:4px double #ddd;font-weight: bold;}.kv-table-footer{border-top:4px double #ddd;font-weight: bold;}.kv-table-caption{font-size:1.5em;padding:8px;border:1px solid #ddd;border-bottom:none;}</style><body class="kv-wrap">{data}</body>',pdf:"{before}\n{data}\n{after}",excel:'<html xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:x="urn:schemas-microsoft-com:office:excel"xmlns="http://www.w3.org/TR/REC-html40"><head><meta http-equiv="Content-Type" content="text/html;charset={encoding}"/>{css}<!--[if gte mso 9]><xml><x:ExcelWorkbook><x:ExcelWorksheets><x:ExcelWorksheet><x:Name>{worksheet}</x:Name><x:WorksheetOptions><x:DisplayGridlines/></x:WorksheetOptions></x:ExcelWorksheet></x:ExcelWorksheets></x:ExcelWorkbook></xml><![endif]--></head><body>{data}</body></html>',popup:'<html style="display:table;width:100%;height:100%;"><title>Grid Export - &copy; Krajee</title><body style="display:table-cell;font-family:Helvetica,Arial,sans-serif;color:#888;font-weight:bold;line-height:1.4em;text-align:center;vertical-align:middle;width:100%;height:100%;padding:0 10px;">{msg}</body></html>'},i=function(t,o){this.$element=e(t),this.$grid=o.grid,this.$table=this.$grid.find(".kv-grid-table"),this.$form=this.$grid.find("form.kv-export-form"),this.encoding=this.$form.find('[name="export_encoding"]').val(),this.filename=o.filename,this.showHeader=o.showHeader,this.columns=o.showHeader?"td,th":"td",this.alertMsg=o.alertMsg,this.messages=o.messages,this.exportConversions=o.exportConversions,this.target=o.target,this.showConfirmAlert=o.showConfirmAlert,this.config=o.config,this.popup="",this.listen()};i.prototype={constructor:i,getArray:function(t){var n=this,i=n.clean(t),r=[],l={};return void 0!=n.config.colHeads&&n.config.colHeads.length>0?r=n.config.colHeads:i.find("thead tr th").each(function(t){var i=e(this).text(),l=slug(i);r[t]=!n.config.slugColHeads||o(l)?"col_"+t:l}),i.find('tbody tr:has("td")').each(function(t){l[t]={},e(this).children("td").each(function(o){var n=r[o];l[t][n]=e(this).text()})}),l},notify:function(e){var t=this;if(!t.showConfirmAlert)return e.preventDefault(),!0;var n=t.messages,i=o(t.alertMsg)?"":t.alertMsg,r=o(n.allowPopups)?"":n.allowPopups,l=o(n.confirmDownload)?"":n.confirmDownload,s="";return s=i.length&&r.length?i+"\n\n"+r:!i.length&&r.length?r:i.length&&!r.length?i:"",l.length&&(s=s+"\n\n"+l),e.preventDefault(),o(s)?!0:t.kvConfirm(s)},kvConfirm:function(e){try{return confirm(e)}catch(t){return!0}},setPopupAlert:function(e){var t=this;if(void 0!=t.popup.document)if(arguments.length&&arguments[1]){var o=t.popup.document.getElementsByTagName("body");setTimeout(function(){o[0].innerHTML=e},4e3)}else{var i=n.popup.replace("{msg}",e);t.popup.document.write(i)}},listenClick:function(e){var t=this,n=arguments.length>1?arguments[1]:"";t.$element.on("click",function(i){t.notify(i)&&(o(n)?t[e]():t[e](n),i.preventDefault())})},listen:function(){var e=this;"_popup"==e.target&&e.$form.on("submit",function(){setTimeout(function(){e.setPopupAlert(e.messages.downloadComplete,!0)},1e3)}),e.$element.hasClass("export-csv")&&e.listenClick("exportTEXT","csv"),e.$element.hasClass("export-txt")&&e.listenClick("exportTEXT","txt"),e.$element.hasClass("export-html")&&e.listenClick("exportHTML"),e.$element.hasClass("export-xls")&&e.listenClick("exportEXCEL"),e.$element.hasClass("export-json")&&e.listenClick("exportJSON"),e.$element.hasClass("export-pdf")&&e.listenClick("exportPDF")},clean:function(e){var t=this,o=t.$table.clone();o.find("tr.filters").remove(),o.find("th").removeAttr("rowspan"),t.showHeader||o.find("thead").remove(),t.showPageSummary||o.find("tfoot.kv-page-summary").remove(),t.showFooter||o.find("tfoot.kv-table-footer").remove(),t.showCaption||o.find("kv-table-caption").remove(),o.find(".skip-export").remove(),o.find(".skip-export-"+e).remove();var n=o.html();return n=t.preProcess(n),o.html(n),o},preProcess:function(e){var o=this,n=o.exportConversions,i=n.length,r=e;if(i>0)for(var l=0;i>l;l++)r=t(r,n[l].from,n[l].to);return r},download:function(e,t){var n=this,i=n.$element.data("format"),r=o(n.config)?{}:n.config;n.$form.find('[name="export_filetype"]').val(e),n.$form.find('[name="export_filename"]').val(n.filename),n.$form.find('[name="export_content"]').val(t),n.$form.find('[name="export_mime"]').val(i),n.$form.find('[name="export_config"]').val("pdf"==e?JSON.stringify(r):""),"_popup"==n.target&&(n.popup=popupDialog("","kvDownloadDialog",350,120),n.popup.focus(),n.setPopupAlert(n.messages.downloadProgress)),n.$form.submit()},exportHTML:function(){var t=this,o=t.clean("html"),i=t.config,r=t.config.cssFile&&i.cssFile.length?'<link href="'+t.config.cssFile+'" rel="stylesheet">':"",l=n.html.replace("{encoding}",t.encoding).replace("{css}",r).replace("{data}",e("<div />").html(o).html());t.download("html",l)},exportPDF:function(){var t=this,i=t.clean("pdf"),r=o(t.config.contentBefore)?"":t.config.contentBefore,l=o(t.config.contentAfter)?"":t.config.contentAfter,s=t.config.css,a=n.pdf.replace("{css}",s).replace("{before}",r).replace("{after}",l).replace("{data}",e("<div />").html(i).html());t.download("pdf",a)},exportTEXT:function(t){var o=this,n=o.clean(t),i=n.find("tr:has("+o.columns+")"),r=String.fromCharCode(11),l=String.fromCharCode(0),s='"'+o.config.colDelimiter+'"',a='"'+o.config.rowDelimiter+'"',c='"'+i.map(function(t,n){var i=e(n),l=i.find(o.columns);return l.map(function(t,o){var n=e(o),i=n.text();return i.replace('"','""')}).get().join(r)}).get().join(l).split(l).join(a).split(r).join(s)+'"';o.download(t,c)},exportJSON:function(){var e=this,t=e.getArray("json"),t=JSON.stringify(t,e.config.jsonReplacer,e.config.indentSpace);e.download("json",t)},exportEXCEL:function(){var t=this,o=t.clean("xls"),i=t.config;o.find("input").remove();var r=i.cssFile&&t.config.cssFile.length?'<link href="'+t.config.cssFile+'" rel="stylesheet">':"",l=n.excel.replace("{encoding}",t.encoding).replace("{css}",r).replace("{worksheet}",t.config.worksheet).replace("{data}",e("<div />").html(o).html()).replace(/"/g,"'");t.download("xls",l)}},e.fn.gridexport=function(t){var o=Array.apply(null,arguments);return o.shift(),this.each(function(){var n=e(this),r=n.data("gridexport"),l="object"==typeof t&&t;r||n.data("gridexport",r=new i(this,e.extend({},e.fn.gridexport.defaults,l,e(this).data()))),"string"==typeof t&&r[t].apply(r,o)})},e.fn.gridexport.defaults={filename:"export",target:"_popup",showHeader:!0,showPageSummary:!0,showFooter:!0,showCaption:!0,showConfirmAlert:!0,alertMsg:"",browserPopupsMsg:"",confirmMsg:"",messages:{allowPopups:"",confirmDownload:"",downloadProgress:"",downloadComplete:""},config:{worksheet:"",colDelimiter:",",rowDelimiter:"\r\n",cssFile:"",colHeads:[],slugColHeads:!1,jsonReplacer:null,indentSpace:4,pdfSettings:""},exportConversions:{}}}(window.jQuery);